/// <reference types="react-reconciler" />
import * as THREE from 'three';
import * as React from 'react';
import { UseStore } from 'zustand';
import { StoreProps, context, RootState, Events } from '../core/store';
import { extend } from '../core/renderer';
import { addEffect, addAfterEffect, addTail } from '../core/loop';
import { createEvents as events } from './events';
import { Canvas } from './Canvas';
export declare type RenderProps = Omit<StoreProps, 'gl' | 'events'> & {
    gl?: THREE.WebGLRenderer | THREE.WebGLRendererParameters;
    events?: (store: UseStore<RootState>) => Events;
    concurrent?: boolean;
};
declare const invalidate: (state?: RootState | undefined) => void;
declare const reconciler: import("react-reconciler").Reconciler<unknown, unknown, unknown, unknown, unknown>, applyProps: (instance: import("../core/renderer").Instance, newProps: import("../core/renderer").InstanceProps, oldProps?: import("../core/renderer").InstanceProps, accumulative?: boolean) => void;
declare function render(element: React.ReactNode, canvas: HTMLCanvasElement, { gl, size, concurrent, events, ...props }?: RenderProps): UseStore<RootState>;
declare function unmountComponentAtNode(canvas: HTMLCanvasElement, callback?: (canvas: HTMLCanvasElement) => void): void;
declare function createPortal(children: React.ReactNode, container: any, impl?: any, key?: any): React.ReactNode;
declare const testutil_act: (callback: () => import("react-reconciler").Thenable<unknown>) => import("react-reconciler").Thenable<void>;
export * from '../core/hooks';
export { context, render, unmountComponentAtNode, createPortal, events, reconciler, applyProps, invalidate, extend, addEffect, addAfterEffect, addTail, Canvas, testutil_act, };
